#include <dlfcn.h>
#include <stdlib.h>

const char* find_myself(void)
{
   void* self = dlopen(NULL, RTLD_LAZY);
   if (self != NULL)
   {
      void* self_pointer = dlsym(self, "find_myself");
      if (self_pointer != NULL)
      {
         Dl_info info;
         int res = dladdr(self_pointer, &info);
         if (res != 0)
         {
            return info.dli_fname;
         }
      }
   }
   return NULL;
}
